/******************************************
Program : HelloWorld Example for Micro64 or Micro128
Company : Micromint, Inc
*********************************************/
     
#include <mega64.h>                     // Comment this line out for Micro128  
// For Micro128 make sure that you goto "Project|Configure", to the 
// "C Compiler" tab and change the chip to ATmega128 
//#include <mega128.h>                  // Uncomment this line for Micro128
#include <stdio.h>			// Standard I/O library

// Declare your global variables here
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7 
#define TXC 6

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
#define TX_COMPETE (1<<TXC)
int COM;         // if COM = 0 then use USART0 if it = 1 then use USART1     
//*********************************************************************************************
// The program lines between the ** lines, like the above line, is needed in order to use the 
// printf command for USART1.

/* inform the compiler that an alternate version 
   of the getchar function will be used for USART1 */
   
#define _ALTERNATE_GETCHAR_

/* now define the new getchar function */
char getchar(void) 
{
/* write your code here */
char status,data;
     switch(COM)
     {
        case 0:
             while (1)
                   {
                   while (((status=UCSR0A) & RX_COMPLETE)==0);
                   data=UDR0;
                   if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
                   return data;
                   };             
        case 1:
             while (1)
                   {
                   while (((status=UCSR1A) & RX_COMPLETE)==0);
                   data=UDR1;
                   if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
                   return data;
                   };
     };
}

/* inform the compiler that an alternate version
   of the putchar function will be used */
#define _ALTERNATE_PUTCHAR_

/* now define the new putchar function */
void putchar(char c) 
{
/* write your code here */ 
     switch(COM)
     {
        case 0:
             while ((UCSR0A & DATA_REGISTER_EMPTY)==0);
             UDR0=c;
             break;
        case 1:
             while ((UCSR1A & DATA_REGISTER_EMPTY)==0);
             UDR1=c; 
             while ((UCSR1A & TX_COMPETE)==0);             
     };
}      
//*********************************************************************************************
void main(void)
{
// Declare your local variables here

// Set up USART1's Baud rate at 9600 bps with a 11.0592 MHz Crystal
UCSR1A=0x00;      // RX EN, TX EN
UCSR1B=0x18;     // RX EN, TX EN
UCSR1C=0x06;     // 8N1
UBRR1H=0x00;    // Baud rate high - 9600
UBRR1L=0x47;   // Baud rate low 

COM = 1;                           // Use USART1  
DDRD.6 = 0;			   // Make PORTD.6 an output  
PORTD.6 = 1; 			   // Enable the RS485 control line 


while (1)
      {    
        printf("Hello World\r\n"); 
      };
}          